import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class AdvertisingEmi {
    
    public static void main(String[] args) {
        FastScanner sc = new FastScanner(System.in);
        
        int n = sc.nextInt();
        
        int[][] graph = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                graph[j][i] = sc.nextInt();
            }
        }
        
        boolean[] visited = new boolean[n];
        visited[0] = true;
        int visitedNum = 1;
        
        Queue<Integer> edges = new LinkedList<>();
        for (int i = 0; i < n; i++) {
            if (graph[0][i] > 0) {
                edges.add(i);
            }
        }
        
        while(!edges.isEmpty() && visitedNum < n) {
            Integer to = edges.poll();
            
            if (!visited[to]) {
                visited[to] = true;
                visitedNum++;
                
                for (int i = 0; i < n; i++) {
                    if (graph[to][i] != 0 && !visited[i]) {
                        edges.add(i);
                    }
                }
            }
        }
        
        int sum = 0;
        // 1 to exclude Lea
        for (int i = 1; i < n; i++) {
            if (visited[i]) {
                int max = 0;
                for (int j = 0; j < n; j++) {
                    if (visited[j] && graph[j][i] > max) {
                        max = graph[j][i];
                    }
                }
                sum += max;
            }
        }
        
        System.out.println(sum + 10);
    }

    static class FastScanner {
        BufferedReader br = null;
        StringTokenizer st = null;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
