import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Set;
import java.util.HashSet;

public class AdvertisingMoritz {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String in = br.readLine();
		int n = Integer.valueOf(in);
		
		int[][] adj = new int[n+1][n+1];
		
		for(int i=1;i<=n;i++) {
			in = br.readLine();
			String[] split = in.split(" ");
			for(int j=1;j<=n;j++) {
				adj[j][i] = Integer.valueOf(split[j-1]);
			}
		}
		
		Queue<Edge> edges = new LinkedList<Edge>();
		for(int i=1;i<=n;i++) {
			if(adj[1][i] > 0) {
				edges.add(new Edge(1,i,adj[1][i]));
			}
		}
		
		boolean seen[] = new boolean[n+1];
		seen[1] = true;
		
		int count = 0;
		Set<Integer> nodes = new HashSet<Integer>();
		nodes.add(1);
		while(!edges.isEmpty() && count < n) {
			Edge e = edges.poll();
			if(!seen[e.to]) {
				count++;	
				seen[e.to] = true;
				nodes.add(e.to);
				for(int i=1;i<=n;i++) {
					if(adj[e.to][i] > 0 && !seen[i]) {
						edges.add(new Edge(e.to,i,adj[e.to][i]));
					}
				}
			}
		}
		
		int sum = 0;
		for(int i: nodes) {
			if(i != 1) {
				int max = 0;
				for(int j: nodes) {
					if(adj[j][i] > max) {
						max = adj[j][i];
					}
				}
				//System.out.println(i + " " + max);
				sum += max;
			}
		}
		
		System.out.println(sum + 10);
	}
	
	public static class Edge implements Comparable<Edge>{
		int from;
		int to;
		int weight;
		
		public Edge(int from, int to, int weight) {
			this.from = from;
			this.to = to;
			this.weight = weight;
		}
		
		public String toString() {
			return from + " " + to + " " + weight;
		}
		
		public int compareTo(Edge e) {
			return e.weight - weight;
		}
	}

}
